Draft BSpline

From FreeCAD Documentation
Jump to: navigation, search
This page contains changes which are not marked for translation.

Other languages:
čeština • ‎Deutsch • ‎English • ‎español • ‎français • ‎italiano • ‎polski • ‎română • ‎русский • ‎svenska • ‎Türkçe

Draft BSpline.png Draft BSpline

Menu location
Draft → BSpline
Workbenches
Draft, Arch
Default shortcut
B S
Introduced in version
0.7
See also
Draft Wire, Draft BezCurve


Description

The BSpline tool creates a B-Spline curve from several points. It uses the Draft Linestyle set on the Draft Tray.

The BSpline tool behaves like the Draft Wire tool, except that each of its segments is curved instead of being a straight line. Use Draft WireToBSpline to convert one to the other.

The BSpline tool specifies the exact points through which the curve will go; on the other hand the Draft BezCurve tool uses control points to define the direction of the curve. To create exact circular or elliptical curves, use Draft Arc and Draft Ellipse.

Draft bspline example.jpg

How to use

  1. Press the Draft BSpline.png Draft BSpline button, or press B then S keys
  2. Click a first point on the 3D view, or type a coordinate and press the Draft AddPoint.svg add point button.
  3. Click additional points on the 3D view, or type a coordinate and press the Draft AddPoint.svg add point button.
  4. Press Esc or the Close button to complete the edition.

The spline can be edited by double clicking on the element in the tree view, or by pressing the Draft Edit.png Draft Edit button. Then you can move the points to a new position, or click Draft AddPoint.svg add point or Draft DelPoint.svg remove point and then click on the wire to add or remove points.

Options

  • Press A or the Draft FinishLine.png Finish button to finish the spline, leaving it open.
  • Press O or the Draft CloseLine.png Close button to close the spline, that is, a curve will be added from the last point to the first one to form a face. At least three points are required to form a face.
  • Press W or the Draft Wipe.svg Wipe button to remove the curve segments already placed, but keep editing the spline from the last point.
  • Press U or the Draft SelectPlane.svg Set WP button to adjust the current working plane in the orientation of the last point.
  • Press X, Y or Z after a point to constrain the next point on the given axis.
  • To enter coordinates manually, simply enter the numbers, then press Enter between each X, Y and Z component. You can press the Draft AddPoint.svg add point button when you have the desired values to insert the point.
  • Press R or click the checkbox to toggle relative mode. If relative mode is on, the coordinates of the next point are relative to the last one; if not, they are absolute, taken from the origin (0,0,0).
  • Press T or click the checkbox to toggle continue mode. If continue mode is on, the BSpline tool will restart after you finish the spline, allowing you to draw another one without pressing the tool button again.
  • Press L or click the checkbox to toggle filled mode. If filled mode is on, a closed spline will create a filled face (DATAMake Face True); if not, the closed spline will not make a face (DATAMake Face False).
Note: the spline should not be filled if it intersects itself, as it won't create a proper face. If the spline is filled but no shape is visible, manually set DATAMake Face to False to see the spline.
  • Hold Ctrl while drawing to force snapping your point to the nearest snap location, independently of the distance.
  • Hold Shift while drawing to constrain your next point horizontally or vertically in relation to the last one.
  • Press Ctrl+Z or press the Draft UndoLine.png Undo button to undo the last point.
  • Press Esc or the Close button to abort the current command; curve segments already placed will remain.

Properties

A BSpline object shares most properties from a Draft Wire, however, most properties only make sense for a Wire.

Data

  • DATAClosed: specifies if the spline is closed or not. If the spline is initially open, this value is False; setting it to True will draw a curve segment to close the spline. If the spline is initially closed, this value is True; setting it to False will remove the last curve segment, and make the spline open.
  • DATAMake Face: specifies if the spline makes a face or not. If it is True a face is created, otherwise only the perimeter is considered part of the object. This property only works if DATAClosed is True.
Note: do not set DATAMake Face to True if the spline intersects itself, as it won't create a proper face.
  • DATAParameterization: affects the shape of the BSpline.

View

  • VIEWArrow Size: specifies the size of the symbol displayed at the end of the spline.
  • VIEWArrow Type: specifies the type of symbol displayed at the end of the spline, which can be "Dot", "Circle", "Arrow", or "Tick".
  • VIEWEnd Arrow: specifies whether to show a symbol at the last point of the spline, so it can be used as an annotation line.
  • VIEWPattern: specifies a Draft Pattern with which to fill the face of a closed spline. This property only works if DATAMake Face is True, and if VIEWDisplay Mode is "Flat Lines".
  • VIEWPattern Size: specifies the size of the Draft Pattern.

Scripting

See also: Draft API and FreeCAD Scripting Basics.

The BSpline tool can be used in macros and from the Python console by using the following function:

BSpline = makeBSpline(pointslist, closed=False, placement=None, face=None, support=None)
BSpline = makeBSpline(Part.Wire, closed=False, placement=None, face=None, support=None) 
  • Creates a BSpline object from the given list of points, pointslist.
    • Each point in the list is defined by its FreeCAD.Vector, with units in millimeters.
    • Alternatively, the input can be a Part.Wire, from which points are extracted.
  • If closed is True, or if the first and last points are identical, the wire is closed.
  • If a placement is given, it is used; otherwise the shape is created at the origin.
  • If face is True, and the spline is closed, the spline will make a face, that is, it will appear filled.

Example:

import FreeCAD, Draft

p1 = FreeCAD.Vector(0, 0, 0)
p2 = FreeCAD.Vector(1000, 1000, 0)
p3 = FreeCAD.Vector(2000, 0, 0)

BSpline1 = Draft.makeBSpline([p1, p2, p3], closed=True)
BSpline2 = Draft.makeBSpline([p1, 2*p3, 1.3*p2], closed=True)
BSpline3 = Draft.makeBSpline([1.3*p3, p1, -1.7*p2], closed=True)